;; find the largest prime factor of the number 317584931803

(defun range (low high)
  (loop for ii from low to (- high 1)
	collect ii))

(defun find-factors (n)
  ;(loop for fact = (ceiling (sqrt n)) then (- fact 1)
  (cons
   n
   (loop for fact = (ceiling (/ n 2)) then (- fact 1)
	 until (< fact 1)
	 when (and (oddp fact) (= 0 (mod n fact)))
	 collect fact)))

(defun find-facts<sqrt (n)
  (cons
   n
   (loop for fact = (ceiling (sqrt n)) then (- fact 1)
	 until (< fact 1)
	 when (and (oddp fact) (= 0 (mod n fact)))
	 collect fact)))

(defun primep (n)
  (and
   (not (= 1 n))
   (equal (list n 1)
	  (find-facts<sqrt n))))


;; for each non-prime, there is a factor that is <= sqrt(n)?
(loop for ii in (range 1 1000)
      do
      (let ((rt (ceiling (sqrt ii))))
	(format t "ii:~a sqrt:~a facts:~a~&"
		ii
		(sqrt ii)
		(remove-if #'(lambda (elt) (> elt rt)) (find-factors ii)))))


;(ceiling (sqrt 317584931803)) => 563,547